﻿using Syncfusion.Windows.Edit;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace EditControlSample
{
    public class CustomLanguage : ProceduralLanguageBase
    {
        private List<EditFormats> formats = new List<EditFormats>()
        {
            new EditFormats() { Foreground = Brushes.Red, FormatName = "KeywordFormat" },
            new EditFormats() { Foreground = Brushes.Red, FormatName = "OperatorFormat" }
        };

        private List<Lexem> lexems = new List<Lexem>()
        {
            // (?i) : Provides Case Insensitivity support in Regex
            new Lexem() { StartText = "hell(?i)(o)", IsRegex = true, LexemType = EditTokenType.Keyword, FormatName = "KeywordFormat" },
            new Lexem() { StartText = "public", LexemType = EditTokenType.Keyword, FormatName = "KeywordFormat"  }
        };

        public CustomLanguage(EditControl control)
            : base(control)
        {
            Name = "Custom";
            FileExtension = "cus";
            ApplyColoring = true;
            SupportsIntellisense = false;
            SupportsOutlining = true;
            CaseSensitive = false;
            TextForeground = Brushes.Black;
            Lexem = new LexemCollection(lexems);
            Formats = new FormatsCollection(formats);
        }
    }
}
